import random

# "💣"
# "🚩"

SIZE = 3
MINES = 0
BOARD = []
FLAGS = 0


def display():
    for x in range(SIZE):
        if x == 0:
            print("╔═" + "══╦═" * (SIZE - 1) + "══╗")
            print("║", end="")
            for y in range(SIZE):
                print(" " + str(BOARD[x][y].status) + "║", end="")
            print("\n╠═" + "══╬═" * (SIZE - 1) + "══╣")
        elif x == SIZE-1:
            print("║", end="")
            for y in range(SIZE):
                print(" " + str(BOARD[x-1][y].status) + "║", end="")
            print("\n╚═" + "══╩═" * (SIZE - 1) + "══╝")
        else:
            print("║", end="")
            for y in range(SIZE):
                print(" " + str(BOARD[x][y].status) + "║", end="")
            print("\n╠═" + "══╬═" * (SIZE - 1) + "══╣")


class Square:

    def __init__(self, x, y):
        self.status = "- "
        self.row = x
        self.column = y
        self.mine = False
        self.neighbours = []
        self.danger = 0


def first_move():
    # establishes mine locations, ignoring starting dig
    print("""Where would you like to start?\n""")
    while True:
        a, b = input("Enter an x and a y coordinate, comma separated, to dig the first square: ").split(",")
        x = int(a)
        y = int(b)
        if x >= SIZE or y >= SIZE:
            print("Out of bounds, try again.")
            continue
        else:
            for m in range(MINES):
                place_mines(x, y)
            welfare(BOARD[x][y])
            break


def place_mines(x, y):
    # Recursively places mines, ignoring starting square
    global BOARD
    h = random.randint(0, SIZE-1)
    w = random.randint(0, SIZE-1)
    if h == x and w == y:
        place_mines(x, y)
    else:
        if not BOARD[h][w].mine:
            BOARD[h][w].mine = True
            for sqr in BOARD[h][w].neighbours:
                sqr.danger += 1
        else:
            place_mines(x, y)


def next_turn():
    # Keeps prompting to dig, flag, or end the game
    move = input("Would you like to '!flag', '!dig', or '!quit'? ").lower()
    if move == "!quit":
        print("Thank you, come again.")
        quit(0)
    elif move == "!dig":
        dig()
        display()
    elif move == "!flag":
        flag()
        display()
    else:
        print("You'll have to speak up, I'm wearing a towel.")


def flag():
    # Flag a square to indicate a potential mine
    while True:
        a, b = input("Supply an x and a y coordinate to flag: ").split(",")
        x = int(a)
        y = int(b)
        if x >= SIZE or y >= SIZE:
            print("Out of bounds, try again.")
            continue
        else:
            global FLAGS
            FLAGS += 1
            global BOARD
            BOARD[x][y].status = "🚩"
            break


def dig():
    # Uncover a square - if it's a bomb, it ends the game. Otherwise reveals nearby empty squares
    while True:
        a, b = input("Supply an x and a y coordinate to flag: ").split(",")
        x = int(a)
        y = int(b)
        if x >= SIZE or y >= SIZE:
            print("Out of bounds, try again.")
            continue
        else:
            if BOARD[x][y].mine is True:
                print("You have died.")
                for x in range(SIZE):
                    for y in range(SIZE):
                        sqr = BOARD[x][y]
                        if sqr.mine is True:
                            sqr.status = "💣"
                display()
                quit(0)
            else:
                BOARD[x][y].status = "x"
                welfare(BOARD[x][y])
                break


def welfare(sqr):
    if sqr.danger == 0:
        sqr.status = "- "
        for box in sqr.neighbours:
            welfare(box)
    else:
        sqr.status = str(sqr.danger) + " "
        for box in sqr.neighbours:
            if not box.mine:
                welfare(box)


    '''
    if sqr.danger != 0:
        sqr.status = str(sqr.danger) + " "
        for box in sqr.neighbours:
            if box.danger == 0:
                welfare(box)
            else:
                box.status = str(box.danger) + " "
    if sqr.danger == 0:
        for box in sqr.neighbours:
            if box.danger != 0 and box.mine:
                welfare(box)
            else:
                box.status = str(box.danger) + " "
                '''


def startup():
    # Set game parameters, give all the squares their neighbours
    print("It's Minesweeper, you know how it works. How wide a board do you want?")
    global SIZE
    while True:
        SIZE = int(input("Give me a size, between 3 and 10 inclusive "))
        if SIZE not in range(3, 11):
            print("Did I fucking stutter? Try again.")
            continue
        else:
            global MINES

            while True:
                MINES = int(input("And how many mines do you want? "))
                if MINES >= SIZE**2:
                    print("Woah, that's too many. Try again.")
                    continue
                else:
                    break

            # initialise an empty board
            global BOARD
            BOARD = [[None for _ in range(SIZE)] for _ in range(SIZE)]

            # fill that board with Square objects
            for s in range(SIZE):
                for d in range(SIZE):
                    BOARD[s][d] = Square(s, d)

            # link each square to it's neighbours
            for a in range(SIZE):
                for b in range(SIZE):
                    sqr = BOARD[a][b]
                    if a == 0:
                        sqr.neighbours.append(BOARD[a+1][b])
                        if b != SIZE-1:
                            sqr.neighbours.append(BOARD[a + 1][b + 1])
                            sqr.neighbours.append(BOARD[a][b+1])
                        if b != 0:
                            sqr.neighbours.append(BOARD[a][b-1])
                            sqr.neighbours.append(BOARD[a+1][b-1])
                    elif a == SIZE-1:
                        sqr.neighbours.append(BOARD[a-1][b])
                        if b != SIZE-1:
                            sqr.neighbours.append(BOARD[a][b+1])
                            sqr.neighbours.append(BOARD[a-1][b+1])
                        if b != 0:
                            sqr.neighbours.append(BOARD[a-1][b-1])
                            sqr.neighbours.append(BOARD[a][b-1])
                    else:
                        sqr.neighbours.append(BOARD[a+1][b])
                        sqr.neighbours.append(BOARD[a-1][b])
                        if b != SIZE-1:
                            sqr.neighbours.append(BOARD[a-1][b+1])
                            sqr.neighbours.append(BOARD[a][b+1])
                            sqr.neighbours.append(BOARD[a+1][b+1])
                        if b != 0:
                            sqr.neighbours.append(BOARD[a-1][b-1])
                            sqr.neighbours.append(BOARD[a][b-1])
                            sqr.neighbours.append(BOARD[a+1][b-1])
            display()
            first_move()
            display()
            break


startup()
while True:
    next_turn()
